GeographicLib 2.3

Static Public Member Functions | Related Functions | List of all members
GeographicLib::Constants Class Reference

Constants needed by GeographicLib More...

`#include <GeographicLib/Constants.hpp>`

## Static Public Member Functions
static Math::real | degree ()
static Math::real | arcminute ()
static Math::real | arcsecond ()
Ellipsoid parameters
template<typename T = real>
static T | WGS84_a ()
template<typename T = real>
static T | WGS84_f ()
template<typename T = real>
static T | WGS84_GM ()
template<typename T = real>
static T | WGS84_omega ()
template<typename T = real>
static T | GRS80_a ()
template<typename T = real>
static T | GRS80_GM ()
template<typename T = real>
static T | GRS80_omega ()
template<typename T = real>
static T | GRS80_J2 ()
template<typename T = real>
static T | UTM_k0 ()
template<typename T = real>
static T | UPS_k0 ()
SI units
template<typename T = real>
static T | meter ()
static Math::real | kilometer ()
static Math::real | nauticalmile ()
template<typename T = real>
static T | square_meter ()
static Math::real | hectare ()
static Math::real | square_kilometer ()
static Math::real | square_nauticalmile ()
Anachronistic British units
static Math::real | foot ()
static Math::real | yard ()
static Math::real | fathom ()
static Math::real | chain ()
static Math::real | furlong ()
static Math::real | mile ()
static Math::real | acre ()
static Math::real | square_mile ()
Anachronistic US units
static Math::real | surveyfoot ()

## Related Functions
(Note that these are not member functions.)
#define | GEOGRAPHICLIB_VERSION_NUM(a, b, c) ((((a) * 10000 + (b)) * 100) + (c))
#define | GEOGRAPHICLIB_VERSION

## Detailed Description

Constants needed by GeographicLib

Define constants specifying the WGS84 ellipsoid, the UTM and UPS projections, and various unit conversions.

Example of use:

// Example of using the GeographicLib::Constants class
#include <iostream>
#include <exception>
#include <GeographicLib/Constants.hpp>
using namespace std;
using namespace GeographicLib;
int main() {
try {
cout << "WGS84 parameters:\n"
<< "a = " << Constants::WGS84_a() << " m\n"
<< "f = 1/" << 1/Constants::WGS84_f() << "\n";
}
catch (const exception& e) {
cerr << "Caught exception: " << e.what() << "\n";
return 1;
}
}
main
int main(int argc, const char *const argv[])
Definition: CartConvert.cpp:29
Constants.hpp
Header for GeographicLib::Constants class.
GeographicLib::Constants::WGS84_f
static T WGS84_f()
Definition: Constants.hpp:141
GeographicLib::Constants::WGS84_a
static T WGS84_a()
Definition: Constants.hpp:135
GeographicLib
Namespace for GeographicLib.
Definition: Accumulator.cpp:12
std
Definition: NearestNeighbor.hpp:812

Definition at line 107 of file Constants.hpp.

## Member Function Documentation

## ◆ degree()

static Math::real GeographicLib::Constants::degree | ( |  | ) |
| inline static

A synonym for Math::degree<real>().

Definition at line 116 of file Constants.hpp.

References GeographicLib::Math::degree().

## ◆ arcminute()

static Math::real GeographicLib::Constants::arcminute | ( |  | ) |
| inline static

Returns
  the number of radians in an arcminute.

Definition at line 120 of file Constants.hpp.

References GeographicLib::Math::degree(), and GeographicLib::Math::dm.

## ◆ arcsecond()

static Math::real GeographicLib::Constants::arcsecond | ( |  | ) |
| inline static

Returns
  the number of radians in an arcsecond.

Definition at line 125 of file Constants.hpp.

References GeographicLib::Math::degree(), and GeographicLib::Math::ds.

## ◆ WGS84_a()

template<typename T = real>

static T GeographicLib::Constants::WGS84_a | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the equatorial radius of WGS84 ellipsoid (6378137 m).

Definition at line 135 of file Constants.hpp.

Referenced by GeographicLib::AlbersEqualArea::AzimuthalEqualAreaNorth(), GeographicLib::AlbersEqualArea::AzimuthalEqualAreaSouth(), GeographicLib::AlbersEqualArea::CylindricalEqualArea(), GeographicLib::UTMUPS::EquatorialRadius(), GeographicLib::Geoid::EquatorialRadius(), GeographicLib::LambertConformalConic::Mercator(), GeographicLib::PolarStereographic::UPS(), GeographicLib::TransverseMercator::UTM(), GeographicLib::TransverseMercatorExact::UTM(), GeographicLib::AuxLatitude::WGS84(), GeographicLib::Geocentric::WGS84(), GeographicLib::Geodesic::WGS84(), GeographicLib::GeodesicExact::WGS84(), GeographicLib::NormalGravity::WGS84(), and GeographicLib::Rhumb::WGS84().

## ◆ WGS84_f()

template<typename T = real>

static T GeographicLib::Constants::WGS84_f | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the flattening of WGS84 ellipsoid (1/298.257223563).

Definition at line 141 of file Constants.hpp.

Referenced by GeographicLib::AlbersEqualArea::AzimuthalEqualAreaNorth(), GeographicLib::AlbersEqualArea::AzimuthalEqualAreaSouth(), GeographicLib::AlbersEqualArea::CylindricalEqualArea(), GeographicLib::UTMUPS::Flattening(), GeographicLib::Geoid::Flattening(), GeographicLib::LambertConformalConic::Mercator(), GeographicLib::PolarStereographic::UPS(), GeographicLib::TransverseMercator::UTM(), GeographicLib::TransverseMercatorExact::UTM(), GeographicLib::AuxLatitude::WGS84(), GeographicLib::Geocentric::WGS84(), GeographicLib::Geodesic::WGS84(), GeographicLib::GeodesicExact::WGS84(), GeographicLib::NormalGravity::WGS84(), and GeographicLib::Rhumb::WGS84().

## ◆ WGS84_GM()

template<typename T = real>

static T GeographicLib::Constants::WGS84_GM | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the gravitational constant of the WGS84 ellipsoid, GM, in m3 s−2.

Definition at line 152 of file Constants.hpp.

Referenced by GeographicLib::NormalGravity::WGS84().

## ◆ WGS84_omega()

template<typename T = real>

static T GeographicLib::Constants::WGS84_omega | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the angular velocity of the WGS84 ellipsoid, ω, in rad s−1.

Definition at line 159 of file Constants.hpp.

Referenced by GeographicLib::NormalGravity::WGS84().

## ◆ GRS80_a()

template<typename T = real>

static T GeographicLib::Constants::GRS80_a | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the equatorial radius of GRS80 ellipsoid, a, in m.

Definition at line 165 of file Constants.hpp.

Referenced by GeographicLib::NormalGravity::GRS80().

## ◆ GRS80_GM()

template<typename T = real>

static T GeographicLib::Constants::GRS80_GM | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the gravitational constant of the GRS80 ellipsoid, GM, in m3 s−2.

Definition at line 172 of file Constants.hpp.

Referenced by GeographicLib::NormalGravity::GRS80().

## ◆ GRS80_omega()

template<typename T = real>

static T GeographicLib::Constants::GRS80_omega | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the angular velocity of the GRS80 ellipsoid, ω, in rad s−1.

This is about 2 π 366.25 / (365.25 × 24 × 3600) rad s−1. 365.25 is the number of days in a Julian year and 365.35/366.25 converts from solar days to sidereal days. Using the number of days in a Gregorian year (365.2425) results in a worse approximation (because the Gregorian year includes the precession of the earth's axis).

Definition at line 186 of file Constants.hpp.

Referenced by GeographicLib::NormalGravity::GRS80().

## ◆ GRS80_J2()

template<typename T = real>

static T GeographicLib::Constants::GRS80_J2 | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the dynamical form factor of the GRS80 ellipsoid, J2.

Definition at line 193 of file Constants.hpp.

Referenced by GeographicLib::NormalGravity::GRS80().

## ◆ UTM_k0()

template<typename T = real>

static T GeographicLib::Constants::UTM_k0 | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the central scale factor for UTM (0.9996).

Definition at line 199 of file Constants.hpp.

Referenced by GeographicLib::TransverseMercator::UTM(), and GeographicLib::TransverseMercatorExact::UTM().

## ◆ UPS_k0()

template<typename T = real>

static T GeographicLib::Constants::UPS_k0 | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the central scale factor for UPS (0.994).

Definition at line 205 of file Constants.hpp.

Referenced by GeographicLib::PolarStereographic::UPS().

## ◆ meter()

template<typename T = real>

static T GeographicLib::Constants::meter | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the number of meters in a meter.

This is unity, but this lets the internal system of units be changed if necessary.

Definition at line 219 of file Constants.hpp.

## ◆ kilometer()

static Math::real GeographicLib::Constants::kilometer | ( |  | ) |
| inline static

Returns
  the number of meters in a kilometer.

Definition at line 223 of file Constants.hpp.

## ◆ nauticalmile()

static Math::real GeographicLib::Constants::nauticalmile | ( |  | ) |
| inline static

Returns
  the number of meters in a nautical mile (approximately 1 arc minute)

Definition at line 229 of file Constants.hpp.

## ◆ square_meter()

template<typename T = real>

static T GeographicLib::Constants::square_meter | ( |  | ) |
| inline static

Template Parameters

  T | the type of the returned value.

Returns
  the number of square meters in a square meter.

This is unity, but this lets the internal system of units be changed if necessary.

Definition at line 239 of file Constants.hpp.

## ◆ hectare()

static Math::real GeographicLib::Constants::hectare | ( |  | ) |
| inline static

Returns
  the number of square meters in a hectare.

Definition at line 244 of file Constants.hpp.

## ◆ square_kilometer()

static Math::real GeographicLib::Constants::square_kilometer | ( |  | ) |
| inline static

Returns
  the number of square meters in a square kilometer.

Definition at line 249 of file Constants.hpp.

## ◆ square_nauticalmile()

static Math::real GeographicLib::Constants::square_nauticalmile | ( |  | ) |
| inline static

Returns
  the number of square meters in a square nautical mile.

Definition at line 254 of file Constants.hpp.

## ◆ foot()

static Math::real GeographicLib::Constants::foot | ( |  | ) |
| inline static

Returns
  the number of meters in an international foot.

Definition at line 264 of file Constants.hpp.

## ◆ yard()

static Math::real GeographicLib::Constants::yard | ( |  | ) |
| inline static

Returns
  the number of meters in a yard.

Definition at line 269 of file Constants.hpp.

## ◆ fathom()

static Math::real GeographicLib::Constants::fathom | ( |  | ) |
| inline static

Returns
  the number of meters in a fathom.

Definition at line 273 of file Constants.hpp.

## ◆ chain()

static Math::real GeographicLib::Constants::chain | ( |  | ) |
| inline static

Returns
  the number of meters in a chain.

Definition at line 277 of file Constants.hpp.

## ◆ furlong()

static Math::real GeographicLib::Constants::furlong | ( |  | ) |
| inline static

Returns
  the number of meters in a furlong.

Definition at line 281 of file Constants.hpp.

## ◆ mile()

static Math::real GeographicLib::Constants::mile | ( |  | ) |
| inline static

Returns
  the number of meters in a statute mile.

Definition at line 285 of file Constants.hpp.

## ◆ acre()

static Math::real GeographicLib::Constants::acre | ( |  | ) |
| inline static

Returns
  the number of square meters in an acre.

Definition at line 289 of file Constants.hpp.

## ◆ square_mile()

static Math::real GeographicLib::Constants::square_mile | ( |  | ) |
| inline static

Returns
  the number of square meters in a square statute mile.

Definition at line 293 of file Constants.hpp.

## ◆ surveyfoot()

static Math::real GeographicLib::Constants::surveyfoot | ( |  | ) |
| inline static

Returns
  the number of meters in a US survey foot.

Definition at line 302 of file Constants.hpp.

## Friends And Related Function Documentation

## ◆ GEOGRAPHICLIB_VERSION_NUM

#define GEOGRAPHICLIB_VERSION_NUM | ( |  | a,
|  |  | b,
|  |  | c
| ) |  | ((((a) * 10000 + (b)) * 100) + (c))
| related

Pack the version components into a single integer. Users should not rely on this particular packing of the components of the version number; see the documentation for GEOGRAPHICLIB_VERSION, below.

Definition at line 21 of file Constants.hpp.

## ◆ GEOGRAPHICLIB_VERSION

#define GEOGRAPHICLIB_VERSION
| related

Value:
GEOGRAPHICLIB_VERSION_NUM(GEOGRAPHICLIB_VERSION_MAJOR, \
GEOGRAPHICLIB_VERSION_MINOR, \
GEOGRAPHICLIB_VERSION_PATCH)
GeographicLib::Constants::GEOGRAPHICLIB_VERSION_NUM
#define GEOGRAPHICLIB_VERSION_NUM(a, b, c)
Definition: Constants.hpp:21

The version of GeographicLib as a single integer, packed as MMmmmmpp where MM is the major version, mmmm is the minor version, and pp is the patch level. Users should not rely on this particular packing of the components of the version number. Instead they should use a test such as

#if GEOGRAPHICLIB_VERSION >= GEOGRAPHICLIB_VERSION_NUM(1,37,0)
...
#endif

Definition at line 34 of file Constants.hpp.

The documentation for this class was generated from the following file:

- Constants.hpp